//#preprocessor

//#ifndef USE_LCMS_LIBRARY

/*
 * File: VEC3.java
 * Version: 2.0
 * Initial Creation: Jul 4, 2010 1:18:56 PM
 *
 * SEE "Little CMS License.txt"
 */
package com.sun.pdfview.helper.graphics.color;

public class VEC3
{
	public double[] vals;
	
	public VEC3()
	{
		this(0, 0, 0);
	}
	
	public VEC3(VEC3 vec)
	{
		this(vec.vals[0], vec.vals[1], vec.vals[2]);
	}
	
	public VEC3(double x, double y, double z)
	{
		vals = new double[3];
		set(x, y, z);
	}
	
	public VEC3(double[] vals, int index)
	{
		this(vals[index], vals[index + 1], vals[index + 2]);
	}
	
	public void set(VEC3 vec)
	{
		System.arraycopy(vec.vals, 0, this.vals, 0, 3);
	}
	
	public void set(double[] vals, int index)
	{
		System.arraycopy(vals, index, this.vals, 0, 3);
	}
	
	public void set(double x, double y, double z)
	{
		this.vals[0] = x;
		this.vals[1] = y;
		this.vals[2] = z;
	}
	
	public double[] getAsArray()
	{
		double[] ary = new double[3];
		System.arraycopy(this.vals, 0, ary, 0, 3);
		return ary;
	}
}

//#endif
